package com.instaply.sdk.proxy.controller;

import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.HEAD;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

import com.instaply.sdk.proxy.dto.NotificationDto;
import com.instaply.sdk.proxy.dto.StatusDto;
import com.instaply.sdk.proxy.service.PushNotificationService;

import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/notifications")
public class NotificationsController {

  private static final Logger logger = LoggerFactory.getLogger(NotificationsController.class);

  @Autowired
  private PushNotificationService pushNotificationService;

  @RequestMapping(method = {GET, HEAD}, produces = APPLICATION_JSON_VALUE)
  public StatusDto status() {
    return new StatusDto();
  }

  @RequestMapping(method = POST, consumes = APPLICATION_JSON_VALUE, produces = APPLICATION_JSON_VALUE,
      headers = "ipns-version=1")
  public void sendPushNotification(@RequestBody @Valid NotificationDto notification) {
    logger.debug("Received push notification request [type: {}, customer: {}]",
        notification.getType(),
        notification.getCustomer().getId());

    pushNotificationService.sendPushNotification(notification);
  }
}
