package com.instaply.sdk.proxy.dto;

import com.instaply.sdk.proxy.validator.NotNullIfTypeIs;

import java.time.OffsetDateTime;

import javax.validation.Valid;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;

import org.hibernate.validator.constraints.NotBlank;

@NotNullIfTypeIs(field = "message", value = NotificationType.message)
public class NotificationDto {
  @NotNull
  private NotificationType type;
  @NotNull
  @Min(0)
  private Integer unreadMessagesCount;
  @NotNull
  private OffsetDateTime date;
  @NotNull
  @Valid
  private CustomerDto customer;
  @Valid
  private MessageDto message;

  public NotificationType getType() {
    return type;
  }

  public int getUnreadMessagesCount() {
    return unreadMessagesCount;
  }

  public OffsetDateTime getDate() {
    return date;
  }

  public CustomerDto getCustomer() {
    return customer;
  }

  public MessageDto getMessage() {
    return message;
  }

  @Override
  public String toString() {
    return "NotificationDto{" +
        "type='" + type + '\'' +
        ", unreadMessagesCount=" + unreadMessagesCount +
        ", date=" + date +
        ", customer=" + customer +
        ", message=" + message +
        '}';
  }

  public static class CustomerDto {
    @NotBlank
    private String id;

    public String getId() {
      return id;
    }

    @Override
    public String toString() {
      return "CustomerDto{" +
          "id='" + id + '\'' +
          '}';
    }
  }
}
