package com.instaply.sdk.proxy.dto;

import org.hibernate.validator.constraints.NotBlank;
import org.hibernate.validator.constraints.URL;

import org.springframework.util.StringUtils;

public class UserDto {
  @NotBlank
  private String firstName;
  private String lastName;
  @URL
  private String picture;

  public String getFirstName() {
    return firstName;
  }

  public String getLastName() {
    return lastName;
  }

  public String getPicture() {
    return picture;
  }

  public String getFullName() {
    return firstName + (StringUtils.isEmpty(lastName) ? "" : (" " + lastName));
  }

  @Override
  public String toString() {
    return "UserDto{" +
        "firstName='" + firstName + '\'' +
        ", lastName='" + lastName + '\'' +
        ", picture='" + picture + '\'' +
        '}';
  }
}
